import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Level here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public abstract class Level extends World
{
    
    protected boolean isComplete = false;
    protected int theme_color_id = 0;
    
    protected OnSpotCounter counter = new OnSpotCounter();
    
    /**
     * Constructor for objects of class Level.
     * 
     */
    public Level(int w, int h, int s)
    {    
        super(w, h, s); 

    }
    
    public boolean levelComplete(){
        return counter.getBlockOnSpotCount() >= counter.getSpotCount();
    }
    
    public void act(){
        //Restart Level if stuck
        if(Greenfoot.isKeyDown("r") && Game.curr_lvl > 0){
            Game.setLevel(Game.curr_lvl);
        }
        
        
    }
    
    public OnSpotCounter getCounter(){
        return counter;
    }
}
