import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class OptionOff here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class OptionOff extends OptionStuffs
{
    public boolean state;
    public boolean select;
    
    private String owner;
    
    private GreenfootImage bgm_normal;
    private GreenfootImage bgm_selected;
    
    public OptionOff(String owner){
        bgm_normal = new GreenfootImage("options/option_off.png");
        bgm_selected = new GreenfootImage("options/option_off_selected.png");
        
        this.owner = owner;
        
        if(owner.equals("sound")){
            if(!Game.soundOn){
                state = true;
            } else {
                state = false;
            }
        } else if (owner.equals("music")){
            if(!Game.musicOn){
                state = true;
            } else {
                state = false;
            }
        }
    }
    
    public void addedToWorld(World world){
        super.addedToWorld(world);
        
        if(owner.equals("sound")){
            if(!Game.soundOn){
                state = true;
            } else {
                state = false;
            }
        } else if (owner.equals("music")){
            if(!Game.musicOn){
                state = true;
            } else {
                state = false;
            }
        }
        
        if(!state){
            bgm_selected.setTransparency(100);
            bgm_normal.setTransparency(100);
        } else {
            bgm_selected.setTransparency(255);
            bgm_normal.setTransparency(255);
        }
        
        if(select){
            setImage(bgm_selected);
        } else {
            setImage(bgm_normal);
        }
    }
    
    public void setSelected(boolean value) 
    {
        select = value;
        if(select){
                setImage(bgm_selected);
            } else {
                setImage(bgm_normal);
            }
    } 
    
    public void setState(boolean value){
        if(owner.equals("sound")){
            if(!state){
                bgm_selected.setTransparency(100);
                bgm_normal.setTransparency(100);
            } else {
                bgm_selected.setTransparency(255);
                bgm_normal.setTransparency(255);
            }
        
            
        } else if(owner.equals("music")){
            if(!state){
                bgm_selected.setTransparency(100);
                bgm_normal.setTransparency(100);
            } else {
                bgm_selected.setTransparency(255);
                bgm_normal.setTransparency(255);
            }
        
            
        }
        
        
        setSelected(select);
    }
    
    public void changeState(){
        if(state){
            state = false;
        } else {
            state = true;
        }
        
        setState(state);
    }
    
}
