import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)


/**
 * Write a description of class Options here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Options extends World
{

    public int selected_index = 0;
    private int delay = 0;
    
    public int start_delay = 0;
    
    private final OptionTitle title = new OptionTitle();
    private final OptionSound sound = new OptionSound();
    private final OptionOn sound_on = new OptionOn("sound");
    private final OptionOff sound_off = new OptionOff("sound");
    private final OptionMusic music = new OptionMusic();
    private final OptionOn music_on = new OptionOn("music");
    private final OptionOff music_off = new OptionOff("music");
    private final OptionBack back = new OptionBack();
    
    /**
     * Constructor for objects of class Options.
     * 
     */
    public Options()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(600, 400, 1); 
        
        getBackground().setColor(Color.BLACK);
        getBackground().fill();
        
        //Options   
        addObject(title,297,67);
        //
        //Sound  On/Off
        addObject(sound,170,157);
        addObject(sound_on,375,157);
        addObject(sound_off,497,157);
        //Music  On/Off
        addObject(music,170,217);
        addObject(music_on,375,217);
        addObject(music_off,497,217);
        //
        //Controls  (Will be later on)
        //Boy    
        //Girl
        //
        //Back
        addObject(back,170,307);
        
        
       
        
    }
    
    public void act(){
        
        
        if(selected_index == 0){
            sound.setSelected(true);
            sound_on.setSelected(true);
            sound_off.setSelected(true);
            music.setSelected(false);
            music_on.setSelected(false);
            music_off.setSelected(false);
            back.setSelected(false);
        } else if(selected_index == 1){
            sound.setSelected(false);
            sound_on.setSelected(false);
            sound_off.setSelected(false);
            music.setSelected(true);
            music_on.setSelected(true);
            music_off.setSelected(true);
            back.setSelected(false);
        } else {
            sound.setSelected(false);
            sound_on.setSelected(false);
            sound_off.setSelected(false);
            music.setSelected(false);
            music_on.setSelected(false);
            music_off.setSelected(false);
            back.setSelected(true);
        }
        
        start_delay++;
        
        if(start_delay <= 10){
            return;
        }
        
        if(delay < 0){
            if(Greenfoot.isKeyDown("left") && selected_index == 0 && !Game.soundOn){
                 Game.soundOn = true;
                 sound_on.changeState();
                 sound_off.changeState();
                } else if(Greenfoot.isKeyDown("right") && selected_index == 0 && Game.soundOn){
                 Game.soundOn = false;
                 sound_on.changeState();
                 sound_off.changeState();
                
        } else if (Greenfoot.isKeyDown("left") && selected_index == 1 && !Game.musicOn){
                 Game.musicOn = true;
                 music_on.changeState();
                 music_off.changeState();
                } else if(Greenfoot.isKeyDown("right") && selected_index == 1 && Game.musicOn){
                 Game.musicOn = false;
                 music_on.changeState();
                 music_off.changeState();
                
        } else {
             if(Greenfoot.isKeyDown("enter")){
                 Sound.moveBlockIntoSpot();
                 Greenfoot.setWorld(new Title());
                }
        }
            
            if (selected_index == 0 && Greenfoot.isKeyDown("down")){
                selected_index = 1;
                Sound.select();
            } else if (selected_index == 1 && Greenfoot.isKeyDown("down")){
                selected_index = 2;
                Sound.select();
            } else if (selected_index == 1 && Greenfoot.isKeyDown("up")){
                selected_index = 0;
                Sound.select();
            } else if (selected_index == 2 && Greenfoot.isKeyDown("up")){
                selected_index = 1;
                Sound.select();
            }
            
            delay = 10;
        }
        
        delay--;
        
        
    }
}
