import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Slime here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Slime extends Enemy
{
    private boolean stopped;
    
    public Slime(){
        super();
        
        spr = new GreenfootImage[9];
        spr[0] = new GreenfootImage("spr_sheet/slime_stand.png");
        spr[1] = new GreenfootImage("spr_sheet/slime_down1.png");
        spr[2] = new GreenfootImage("spr_sheet/slime_down2.png");
        spr[3] = new GreenfootImage("spr_sheet/slime_left1.png");
        spr[4] = new GreenfootImage("spr_sheet/slime_left2.png");
        spr[5] = new GreenfootImage("spr_sheet/slime_right1.png");
        spr[6] = new GreenfootImage("spr_sheet/slime_right2.png");
        spr[7] = new GreenfootImage("spr_sheet/slime_up1.png");
        spr[8] = new GreenfootImage("spr_sheet/slime_up2.png");
    }
    
    
    public void moveAI(){
        setLocation(x,y);
        move_delay--;
        if (canMove && !dead && move_delay < 0){
            int decision_dir = Greenfoot.getRandomNumber(3);
            if (detectPlayerIsNearInDirection() > -1){
                decision_dir = detectPlayerIsNearInDirection();
            } 
            
            if (checkMovable(decision_dir)){
                moveDecision(decision_dir);
                stopped = false;
            }else {
                stopped = true;
            }
            move_delay = 100;
            if (!stopped)
                 changeFacingDir();
            else
               spr_i = 0;
            animate();
        } 
        
    }
    
    public void changeFacingDir(){
        if(facing_dir == 0){
            spr_i = Greenfoot.getRandomNumber(1)+1;
        } else if(facing_dir == 1){
            spr_i = Greenfoot.getRandomNumber(1)+3;
        } else if(facing_dir == 2){
            spr_i = Greenfoot.getRandomNumber(1)+5;
        } else if(facing_dir == 3){
            spr_i = Greenfoot.getRandomNumber(1)+7;
        }
        
        
    }
    
    private void animate(){
        setImage(spr[spr_i]);
    }
    
    public int detectPlayerIsNearInDirection(){
        if (getOneObjectAtOffset(0, 8, Player.class) != null){
            return 0;
        } else if (getOneObjectAtOffset(-8, 0, Player.class) != null){
            return 1;
        } else if (getOneObjectAtOffset(8, 0, Player.class) != null){
            return 2;
        } else if (getOneObjectAtOffset(0, -8, Player.class) != null){
            return 3;
        } else if (getOneObjectAtOffset(0, 4, Player.class) != null){
            return 0;
        } else if (getOneObjectAtOffset(-4, 0, Player.class) != null){
            return 1;
        } else if (getOneObjectAtOffset(4, 0, Player.class) != null){
            return 2;
        } else if (getOneObjectAtOffset(0, -4, Player.class) != null){
            return 3;
        }else {
            return -1;
        }
    }
    
}
