import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class LevelComplete here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class LevelComplete extends Actor
{
    
    private static final GreenfootImage WHITE = new GreenfootImage("lvl_complete.png");
    private static final GreenfootImage BLUE = new GreenfootImage("lvl_complete0.png");
    private static final GreenfootImage GREEN = new GreenfootImage("lvl_complete1.png");
    private static final GreenfootImage YELLOW = new GreenfootImage("lvl_complete2.png");
    private static final GreenfootImage PINK = new GreenfootImage("lvl_complete3.png");
    private static final GreenfootImage RED = new GreenfootImage("lvl_complete4.png");
    
    private int color_id;
    private int color_delay = 3;
    private int color_switch = 0;
    
    public LevelComplete(){
        color_id = 0;
        
        WHITE.setTransparency(200);
        BLUE.setTransparency(200);
        GREEN.setTransparency(200);
        YELLOW.setTransparency(200);
        PINK.setTransparency(200);
        RED.setTransparency(200);
        setImage(WHITE);
        
        Sound.levelComplete();
    }
    
    public LevelComplete(int color_id){
        this.color_id = color_id;
        
        WHITE.setTransparency(200);
        BLUE.setTransparency(200);
        GREEN.setTransparency(200);
        YELLOW.setTransparency(200);
        PINK.setTransparency(200);
        RED.setTransparency(200);
        setImage(WHITE);
        
        Sound.levelComplete();
    }
    
    public void act(){
        if(Greenfoot.isKeyDown("enter")){
            Game.setLevel(Game.curr_lvl+1);
            Sound.levelUp();
            getWorld().removeObject(this);
            return;
        }
        
        color_delay--;
        
        if(color_delay < 0){
            if(color_switch == 0){
                color_switch = 1;
                switch(color_id){
                    case 0: setImage(BLUE);break;
                    case 1: setImage(GREEN);break;
                    case 2: setImage(YELLOW);break;
                    case 3: setImage(PINK);break;
                    case 4: setImage(RED);break;
                    default: setImage(WHITE);
                }
            } else {
                color_switch = 0;
                setImage(WHITE);
            }
                color_delay = 3;
        }
    }
}
