import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class OptionOn here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class OptionOn extends OptionStuffs
{
    public boolean state;
    public boolean select;
    
    private String owner;
    
    private GreenfootImage snd_normal;
    private GreenfootImage snd_selected;
  
    
    public OptionOn(String owner){
        snd_normal = new GreenfootImage("options/option_on.png");
        snd_selected = new GreenfootImage("options/option_on_selected.png");
        
        this.owner = owner;
        
        if(owner.equals("sound")){
            if(Game.soundOn){
                state = true;
            } else {
                state = false;
            }
        } else if (owner.equals("music")){
            if(Game.musicOn){
                state = true;
            } else {
                state = false;
            }
        }
    }
    
    public void addedToWorld(World world){
        super.addedToWorld(world);
        
        if(owner.equals("sound")){
            if(Game.soundOn){
                state = true;
            } else {
                state = false;
            }
        } else if (owner.equals("music")){
            if(Game.musicOn){
                state = true;
            } else {
                state = false;
            }
        }
        
        if(!state){
            snd_selected.setTransparency(100);
            snd_normal.setTransparency(100);
        } else {
            snd_selected.setTransparency(255);
            snd_normal.setTransparency(255);
        }
        
        if(select){
            setImage(snd_selected);
        } else {
            setImage(snd_normal);
        }
    }
    
    public void setSelected(boolean value) 
    {
        select = value;
        if(select){
                setImage(snd_selected);
            } else {
                setImage(snd_normal);
            }
    } 
    
    public void setState(boolean value){
        if(owner.equals("sound")){
            if(!state){
                snd_selected.setTransparency(100);
                snd_normal.setTransparency(100);
            } else {
                snd_selected.setTransparency(255);
                snd_normal.setTransparency(255);
            }
        
            
        } else if(owner.equals("music")){
            if(!state){
                snd_selected.setTransparency(100);
                snd_normal.setTransparency(100);
            } else {
                snd_selected.setTransparency(255);
                snd_normal.setTransparency(255);
            }
        
            
        }
        
        
        setSelected(select);
    }
    
    
    public void changeState(){
        if(state){
            state = false;
        } else {
            state = true;
        }
        
        setState(state);
    }
   
}
